unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CommPort, StdCtrls, ComCtrls, ExtCtrls, Spin, UStepperMotorControl,
  Math, Registry, Joystickex;

type
  TMainForm = class(TForm)
    Label13: TLabel;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label3: TLabel;
    Timer1: TTimer;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    TrackBar1: TTrackBar;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    TrackBar2: TTrackBar;
    Button1: TButton;
    Label2: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    GroupBox4: TGroupBox;
    Label25: TLabel;
    TrackBar3: TTrackBar;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Edit1: TEdit;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Edit2: TEdit;
    Label34: TLabel;
    Button3: TButton;
    Button4: TButton;
    Joystickex1: TJoystickex;
    GroupBox5: TGroupBox;
    CheckBox7: TCheckBox;
    Label35: TLabel;
    Label36: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    TrackBar4: TTrackBar;
    Kalibrovat: TButton;
    CheckBox8: TCheckBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Label37: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Timer2: TTimer;
    Label43: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure Joystickex1JoyMove(Sender: TObject; XPos, YPos: Integer;
      ButtonStatus: Word; IsCalibrating: Boolean);
    procedure TrackBar4Change(Sender: TObject);
    procedure KalibrovatClick(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
  private
    { Private declarations }
  public
    LastButtonStatus: Integer;
    Registry: TRegistry;
    DifferentialDrive: TDifferentialDrive;
    MoveSpeedMin: Double;
    MoveSpeedMax: Double;
    RotateSpeedMin: Double;
    RotateSpeedMax: Double;
    procedure ShowRobotInfo(Sender: TObject);
    procedure ShowInfo(Sender: TObject);
    procedure ShowInfo2(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

uses UPositionDisplayForm;

{$R *.dfm}

procedure TMainForm.FormShow(Sender: TObject);
begin
  DifferentialDrive.OnMove := PositionDisplay.DrawMove;
  DifferentialDrive.OnChange := ShowRobotInfo;
//  TrackBar3.Position := 100;
  PositionDisplay.Show;
  CheckBox7.Checked := True;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
  Buffer: string;
  I: Integer;
begin
  with DifferentialDrive do begin
  if CommPort.Open then Label1.Caption := 'Oteven' else
    Label1.Caption := 'Zaven';
//  if CommPort1.Enabled then Label2.Caption := 'Oteven' else
//    Label2.Caption := 'Zaven';
//  Label3.Caption := IntToStr(CommPort1.InBuffUsed);
//  Label3.Caption := IntToStr(CommPort1.OutBuffUsed);
  SetLength(Buffer, CommPort.InBuffUsed);
  CommPort.GetBlock(Buffer[1], Length(Buffer));
//  for I := 1 to Length(Buffer) do
//    TrackBar2.Position := Ord(Buffer[I]);
  end;
end;

procedure TMainForm.TrackBar1Change(Sender: TObject);
begin
//  DifferentialDrive.Motors[0].StepPeriod := TrackBar1.Position;
  with DifferentialDrive.Motors[0] do
    RevolutionsPerSecond := TrackBar1.Position / High(SmallInt) * (MaxRevolutions - MinRevolutions) + Sign(TrackBar1.Position) * MinRevolutions;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  TrackBar1.Position := 0;
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
begin
  with DifferentialDrive do begin
    CommPort.Open := False;
    CommPort.ComNumber := ComboBox1.ItemIndex + 1;
    CommPort.Open := True;
  end;
end;

procedure TMainForm.ComboBox2Change(Sender: TObject);
begin
  DifferentialDrive.Motors[0].MotorControlProtocol.SetBaudRate(StrToInt(ComboBox2.Items[ComboBox2.ItemIndex]));
end;

procedure TMainForm.ShowRobotInfo(Sender: TObject);
begin
  ShowInfo(Self);
  ShowInfo2(Self);

  Label26.Caption := FloatToStrF(DifferentialDrive.Speed, ffGeneral, 4, 10) + ' m/s';
  Label28.Caption := FloatToStrF(DifferentialDrive.Angle / Pi * 180, ffGeneral, 4, 10) + ' ';
  Label39.Caption := FloatToStrF(DifferentialDrive.Omega / Pi * 180, ffGeneral, 4, 10) + ' /s';
  Label30.Caption := FloatToStrF(DifferentialDrive.X / Pi * 180, ffGeneral, 4, 10) + ', ' +
    FloatToStrF(DifferentialDrive.Y / Pi * 180, ffGeneral, 4, 10);
  Edit1.Text := FloatToStr(DifferentialDrive.WheelsDiameter);
  Edit2.Text := FloatToStr(DifferentialDrive.WheelsDistance);
end;

procedure TMainForm.ShowInfo(Sender: TObject);
begin
  with DifferentialDrive.Motors[0] do begin
    Label24.Caption := IntToStr(StepPeriod);
    Label15.Caption := FloatToStrF(RevolutionsPerSecond, ffGeneral, 4, 10) + ' otek/sekundu';
    Label14.Caption := FloatToStrF(StepsPerSeconds, ffGeneral, 4, 10) + ' krok/sekundu';
    Label11.Caption := FloatToStrF(RevolutionsPerSecond * 60, ffGeneral, 4, 10) + ' otek/minutu';
  end;
end;

procedure TMainForm.ShowInfo2(Sender: TObject);
begin
  with DifferentialDrive.Motors[1] do begin
    Label2.Caption := IntToStr(StepPeriod);
    Label18.Caption := FloatToStrF(RevolutionsPerSecond, ffGeneral, 4, 10) + ' otek/sekundu';
    Label17.Caption := FloatToStrF(StepsPerSeconds, ffGeneral, 4, 10) + ' krok/sekundu';
    Label16.Caption := FloatToStrF(RevolutionsPerSecond * 60, ffGeneral, 4, 10) + ' otek/minutu';
  end;
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  DifferentialDrive.Motors[0].FreeWheel := CheckBox1.Checked;
end;

procedure TMainForm.CheckBox2Click(Sender: TObject);
begin
  DifferentialDrive.Motors[0].HalfStep := CheckBox2.Checked;
end;

procedure TMainForm.CheckBox3Click(Sender: TObject);
begin
  DifferentialDrive.Motors[0].OutputLines := CheckBox3.Checked;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DifferentialDrive.Free;
  Registry.WriteFloat('WheelsDistance', DifferentialDrive.WheelsDistance);
  Registry.WriteFloat('WheelsDiameter', DifferentialDrive.WheelsDiameter);
  Registry.WriteFloat('WheelsMinRevolutions', DifferentialDrive.Motors[0].MinRevolutions);
  Registry.WriteFloat('WheelsMaxRevolutions', DifferentialDrive.Motors[0].MaxRevolutions);
  Registry.WriteInteger('JoystickCalibrationMinX', Joystickex1.MaxLeftUP.X);;
  Registry.WriteInteger('JoystickCalibrationMinY', Joystickex1.MaxLeftUP.Y);;
  Registry.WriteInteger('JoystickCalibrationMaxX', Joystickex1.MaxRightDown.X);;
  Registry.WriteInteger('JoystickCalibrationMaxY', Joystickex1.MaxRightDown.Y);;
  Registry.WriteFloat('MoveSpeedMin', MoveSpeedMin);;
  Registry.WriteFloat('MoveSpeedMax', MoveSpeedMax);;
  Registry.WriteFloat('RotateSpeedMin', RotateSpeedMin);;
  Registry.WriteFloat('RotateSpeedMax', RotateSpeedMax);;
  Registry.Free;
end;

procedure TMainForm.TrackBar2Change(Sender: TObject);
begin
  with DifferentialDrive.Motors[1] do
    RevolutionsPerSecond := TrackBar2.Position / High(SmallInt) * (MaxRevolutions - MinRevolutions) + Sign(TrackBar2.Position) * MinRevolutions;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  TrackBar2.Position := 0;
end;

procedure TMainForm.CheckBox4Click(Sender: TObject);
begin
  DifferentialDrive.Motors[1].FreeWheel := CheckBox4.Checked;
end;

procedure TMainForm.CheckBox5Click(Sender: TObject);
begin
  DifferentialDrive.Motors[1].HalfStep := CheckBox5.Checked;
end;

procedure TMainForm.CheckBox6Click(Sender: TObject);
begin
  DifferentialDrive.Motors[1].OutputLines := CheckBox6.Checked;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Registry := TRegistry.Create;
  Registry.RootKey := HKEY_CURRENT_USER;
  Registry.OpenKey('\Software\Chronosoft\Robot control', True);

  DifferentialDrive := TDifferentialDrive.Create;
  with DifferentialDrive do begin
    if not Registry.ValueExists('WheelsDiameter') then Registry.WriteFloat('WheelsDiameter', 0.1);
    WheelsDiameter := Registry.ReadFloat('WheelsDiameter');;
    if not Registry.ValueExists('WheelsDistance') then Registry.WriteFloat('WheelsDistance', 0.34);
    WheelsDistance := Registry.ReadFloat('WheelsDistance');;
    if not Registry.ValueExists('WheelsMinRevolutions') then Registry.WriteFloat('WheelsMinRevolutions', 0.1);
    Motors[0].MinRevolutions := Registry.ReadFloat('WheelsMinRevolutions');
    Motors[1].MinRevolutions := Registry.ReadFloat('WheelsMinRevolutions');
    if not Registry.ValueExists('WheelsMaxRevolutions') then Registry.WriteFloat('WheelsMaxRevolutions', 3);
    Motors[0].MaxRevolutions := Registry.ReadFloat('WheelsMaxRevolutions');
    Motors[1].MaxRevolutions := Registry.ReadFloat('WheelsMaxRevolutions');
    if not Registry.ValueExists('JoystickCalibrationMinX') then Registry.WriteInteger('JoystickCalibrationMinX', -300);
    Joystickex1.FMaxLeftUP.X := Registry.ReadInteger('JoystickCalibrationMinX');
    if not Registry.ValueExists('JoystickCalibrationMinY') then Registry.WriteInteger('JoystickCalibrationMinY', -300);
    Joystickex1.FMaxLeftUP.Y := Registry.ReadInteger('JoystickCalibrationMinY');
    if not Registry.ValueExists('JoystickCalibrationMaxX') then Registry.WriteInteger('JoystickCalibrationMaxX', 300);
    Joystickex1.FMaxRightDown.X := Registry.ReadInteger('JoystickCalibrationMaxX');
    if not Registry.ValueExists('JoystickCalibrationMaxY') then Registry.WriteInteger('JoystickCalibrationMaxY', 300);
    Joystickex1.FMaxRightDown.Y := Registry.ReadInteger('JoystickCalibrationMaxY');

    if not Registry.ValueExists('MoveSpeedMin') then Registry.WriteFloat('MoveSpeedMin', 0.03);
    MoveSpeedMin := Registry.ReadFloat('MoveSpeedMin');
    Edit3.Text := FloatToStr(MoveSpeedMin);
    if not Registry.ValueExists('MoveSpeedMax') then Registry.WriteFloat('MoveSpeedMax', 0.3);
    MoveSpeedMax := Registry.ReadFloat('MoveSpeedMax');
    Edit4.Text := FloatToStr(MoveSpeedMax);
    if not Registry.ValueExists('RotateSpeedMin') then Registry.WriteFloat('RotateSpeedMin', 0.03);
    RotateSpeedMin := Registry.ReadFloat('RotateSpeedMin');
    Edit5.Text := FloatToStr(RotateSpeedMin);
    if not Registry.ValueExists('RotateSpeedMax') then Registry.WriteFloat('RotateSpeedMax', 0.3);
    RotateSpeedMax := Registry.ReadFloat('RotateSpeedMax');
    Edit6.Text := FloatToStr(RotateSpeedMax);
  end;
end;

procedure TMainForm.TrackBar3Change(Sender: TObject);
begin
  if TrackBar3.Position = 0 then DifferentialDrive.Speed := 0
  else DifferentialDrive.Speed := MoveSpeedMin + TrackBar3.Position / 100 * (MoveSpeedMax - MoveSpeedMin);
end;

procedure TMainForm.Edit1Change(Sender: TObject);
var
  Value: Double;
begin
  if TryStrToFloat(Edit1.Text, Value) then DifferentialDrive.WheelsDiameter := Value;
end;

procedure TMainForm.Edit2Change(Sender: TObject);
var
  Value: Double;
begin
  if TryStrToFloat(Edit2.Text, Value) then DifferentialDrive.WheelsDistance := Value;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  if Button3.Caption = 'Zastavit' then begin
    DifferentialDrive.AllStop := True;
    Button3.Caption := 'Rozjet';
  end else begin
    DifferentialDrive.AllStop := False;
    Button3.Caption := 'Zastavit';
  end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  DifferentialDrive.Reset;
end;

procedure TMainForm.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked then begin
    if not Joystickex1.EnableJoystick then
      ShowMessage('Joystick nenalezen!');
  end else begin
    Joystickex1.DisableJoystick;
  end;
end;

procedure TMainForm.Joystickex1JoyMove(Sender: TObject; XPos,
  YPos: Integer; ButtonStatus: Word; IsCalibrating: Boolean);
const
  Insensitivity = 0.1;
var
  JoyX: Real;
  JoyY: Real;
begin
  Label36.Caption := 'X : '+IntToStr(Xpos)+'/ Y : ' +IntToStr(Ypos)+ ' Buttons : ' + IntToStr(ButtonStatus);
  if CheckBox8.Checked then with JoystickEx1 do begin
    JoyX := XPos / 400;
    JoyY := -YPos / 300;
    // Vle v pevodech
    if (JoyX <= Insensitivity) and (JoyX >= -Insensitivity) then TrackBar4.Position := 0
    else TrackBar4.Position := Round((JoyX - Sign(JoyX)*Insensitivity) / (1 - Insensitivity) * 100);
    if (JoyY <= Insensitivity) and (JoyY >= -Insensitivity) then TrackBar3.Position := 0
    else TrackBar3.Position := Round((JoyY - Sign(JoyY)*Insensitivity) / (1 - Insensitivity) * 100);

    // Buttons actions
    if LastButtonStatus <> ButtonStatus then begin
    if (ButtonStatus and $1) > 0 then begin // Volnobh
      CheckBox1.Checked := not CheckBox1.Checked;
      CheckBox4.Checked := not CheckBox4.Checked;
    end;
    if (ButtonStatus and $2) > 0 then begin // Polovin krok
      CheckBox2.Checked := not CheckBox2.Checked;
      CheckBox5.Checked := not CheckBox5.Checked;
    end;
    if (ButtonStatus and $4) > 0 then begin // zen vstupnch linek
      CheckBox3.Checked := not CheckBox3.Checked;
      CheckBox6.Checked := not CheckBox6.Checked;
    end;
    end;
  end;
  LastButtonStatus := ButtonStatus;
end;

procedure TMainForm.TrackBar4Change(Sender: TObject);
begin
  if TrackBar4.Position = 0 then DifferentialDrive.Omega := 0
  else DifferentialDrive.Omega := RotateSpeedMin + TrackBar4.Position / 100 * (RotateSpeedMax - RotateSpeedMin);
end;

procedure TMainForm.KalibrovatClick(Sender: TObject);
begin
  ShowMessage ('Nechte joystick '+ IntToStr(Ord(Joystickex1.GamePort)+1)+ ' v stedn poloze! Pak stisknte tlatko Ok.');
  Joystickex1.CalibrateCenter;

  if not Joystickex1.BeginCalibrateRange then begin
    ShowMessage('Joystick nelze kalibrovat, protoe nen aktivn.');
    exit;
  end;

  ShowMessage('Nyn pohnte joytickem do maxima v kadm smru. Pak stisknte Ok.');
  Joystickex1.StopCalibrateRange;
end;

procedure TMainForm.Edit3Change(Sender: TObject);
begin
  TryStrToFloat(Edit3.Text, MoveSpeedMin);
end;

procedure TMainForm.Edit4Change(Sender: TObject);
begin
  TryStrToFloat(Edit4.Text, MoveSpeedMax);
end;

procedure TMainForm.Edit5Change(Sender: TObject);
begin
  TryStrToFloat(Edit5.Text, RotateSpeedMin);
end;

procedure TMainForm.Edit6Change(Sender: TObject);
begin
  TryStrToFloat(Edit6.Text, RotateSpeedMax);
end;

end.
