unit UPositionDisplayForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TPositionDisplay = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    X, Y: Real;
    Angle: Real;
    LastPosition: TPoint;
    procedure DrawMove(Sender: TObject);
  end;

var
  PositionDisplay: TPositionDisplay;

implementation

uses UMainForm, UStepperMotorControl;

{$R *.dfm}

{ TPositionDisplay }

procedure TPositionDisplay.DrawMove(Sender: TObject);
begin
  if Sender is TDifferentialDrive then with TDifferentialDrive(Sender), Canvas do begin
    Self.X := X;
    Self.Y := Y;
    Self.Angle := Angle;
  end;
end;

procedure TPositionDisplay.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MainForm.DifferentialDrive.MoveTo((X - Image1.Width / 2) / 100, (Y - Image1.Height / 2) / 100);
end;

procedure TPositionDisplay.FormCreate(Sender: TObject);
begin
  LastPosition.X := Image1.Width div 2;
  LastPosition.Y := Image1.Height div 2;
end;

procedure TPositionDisplay.Timer1Timer(Sender: TObject);
const
  R = 10;
begin
  with Image1.Canvas do begin
    Pen.Color := clGreen;
    MoveTo(LastPosition.X, LastPosition.Y);
    LineTo(Round(LastPosition.X + Cos(Angle) * R), Round(LastPosition.Y + Sin(Angle) * R));
    Pen.Color := clRed;
    MoveTo(LastPosition.X, LastPosition.Y);
    LastPosition.X := Round(Width / 2 + X * 100);
    LastPosition.Y := Round(Height / 2 + Y * 100);
    LineTo(LastPosition.X, LastPosition.Y);
    MainForm.ShowRobotInfo(Self);
    Application.ProcessMessages;
  end;
end;

end.
